#include "X3D_MyBBoxUpdaterGeometry3DVisitor.h"
#include "X3D_Icosahedron.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

MyBBoxUpdaterGeometry3DVisitor::MyBBoxUpdaterGeometry3DVisitor()
: BBoxUpdaterGeometry3DVisitor()
{
  // Defines the new enter function for the X3DAbstractNode.
  defineEnterFunction(&MyBBoxUpdaterGeometry3DVisitor::enterIcosahedron);
}

void MyBBoxUpdaterGeometry3DVisitor::enterIcosahedron(Icosahedron *I) const
{
  // Checking whether the BBox of the node has already been computed.
  BBox *BB = stateVariables->getBBox(I);
  if (BB == 0)
  {
    BB = new BBox(SFVec3f(0.0f, 0.0f, 0.0f), SFVec3f(2.0f*I->getRadius(), 2.0f*I->getRadius(), 2.0f*I->getRadius()));
    stateVariables->addBBox(I, BB);
    stateVariables->setShapeBBox(*BB);
  }
}

}
}
