#include "MESH_TransformComputer.h"
#include "MESH_TransformComputerCoreVisitor.h"

namespace X3DTK {
namespace MESH {

MeshTransformComputer::MeshTransformComputer()
{
  stateVariables = GraphTraversal::getInstanceOf<MeshTransformComputerStateVariables>();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MeshTransformComputerCoreVisitor());
}

MeshTransformComputer::~MeshTransformComputer()
{
  GraphTraversal::removeInstanceOf<MeshTransformComputerStateVariables>();

  delete graphTraversal;
}

void MeshTransformComputer::print(SFNode N)
{
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
}

}
}

