#include "MESH_TransformComputerCoreVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

MeshTransformComputerCoreVisitor::MeshTransformComputerCoreVisitor()
{
  // Enter functions.
  defineEnterFunction(&MeshTransformComputerCoreVisitor::enterMesh);
  defineEnterFunction(&MeshTransformComputerCoreVisitor::enterTransform);
  
  // Leave functions.
  defineLeaveFunction(&MeshTransformComputerCoreVisitor::leaveX3DGroupingNode);
  
  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<MeshTransformComputerStateVariables>();
}

MeshTransformComputerCoreVisitor::~MeshTransformComputerCoreVisitor()
{
}

void MeshTransformComputerCoreVisitor::enterMesh(Mesh *M) const
{
  cout << "enter Mesh" << endl;
  cout << "Transform:" << endl << stateVariables->getMatrix() << endl;
  cout << "  number of vertices = " << M->getVertices().size() << endl;
  for (Mesh::MFVertex::const_iterator it = M->getVertices().begin(); it != M->getVertices().end(); ++it)
    cout << (*it)->data().getPoint() << endl;
}

void MeshTransformComputerCoreVisitor::enterTransform(Transform *T) const
{
  stateVariables->pushMatrix(T->getTransform());
}

void MeshTransformComputerCoreVisitor::leaveX3DGroupingNode(X3DGroupingNode *N) const
{
  stateVariables->popMatrix();
}

}
}
