////////////////////////////////////////////////////////////////////////////////
///                            MESH_MyStructureComputerCoreVisitor.h         ///
////////////////////////////////////////////////////////////////////////////////

#ifndef MYSTRUCTURECOMPUTERCOREVISITOR_H
#define MYSTRUCTURECOMPUTERCOREVISITOR_H

#include <X3DTK/mesh_scenegraph.h>

#include "MESH_MyStructureComputerStateVariables.h"

namespace X3DTK {
namespace MESH {

class X3DGroupingNode;
class Transform;

/// Visitor for the Core component of the MyStructureComputer module.

class MyStructureComputerCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  MyStructureComputerCoreVisitor();
  /// Destructor.
  virtual ~MyStructureComputerCoreVisitor();

  /// Enters a Mesh.
  virtual void enterMesh(Mesh *M) const;

  /// Enters a Transform.
  virtual void enterTransform(Transform *T) const;

  /// Leaves a Scene.
  virtual void leaveX3DGroupingNode(X3DGroupingNode *N) const;

protected:
  MyStructureComputerStateVariables *stateVariables;
};

}
}

#endif
