////////////////////////////////////////////////////////////////////////////////
///                            GL_SimpleAnimatorStateVariables.h             ///
////////////////////////////////////////////////////////////////////////////////

#ifndef GLSIMPLEANIMATORGLOBALVARIABLES_H
#define GLSIMPLEANIMATORGLOBALVARIABLES_H

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace GL {

/// StateVariables for the SimpleAnimator module.

class SimpleAnimatorStateVariables : public StateVariables
{
public:
  /// Constructor.
  SimpleAnimatorStateVariables();
  /// Destructor.
  virtual ~SimpleAnimatorStateVariables();

  /// Sets the bboxSize.
  void setBBoxSize(const SFVec3f &size);
  /// Sets the time.
  void setTime(float time);

  /// Gets the time.
  float getTime() const {return _time;};
  /// Sets the bboxSize.
  inline SFVec3f getBBoxSize() const {return _bboxSize;};
  
private: 
  float _time;
  SFVec3f _bboxSize;
};

}
}

#endif
