/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            MESH_MeshX3DBuilderCoreVisitor.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHX3DBUILDERVISITOR_H
#define MESHX3DBUILDERVISITOR_H

#include "MESH_CoreVisitor.h"
#include "MESH_Mesh.h"
#include "MESH_VertexSet.h"
#include "MESH_MeshX3DBuilderStateVariables.h"

namespace X3DTK {
namespace MESH {

class Scene;
class X3DNode;
class Transform;
class Switch;

class X3DTK_API MeshX3DBuilderCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  MeshX3DBuilderCoreVisitor();

  /// Enters a Scene.
  virtual void enterScene(Scene *S) const; 
  /// Enters a Transform.
  virtual void enterTransform(Transform *T) const; 
  /// Enters a Switch.
  virtual void enterSwitch(Switch *S) const;
  /// Enters a Mesh.
  virtual void enterMesh(Mesh *M) const;
  /// Enters a VertexSet.
  virtual void enterVertexSet(VertexSet *V) const;
  
  /// Leaves an X3DNode.
  virtual void leaveX3DNode(X3DNode *N) const;
  /// Leaves a Mesh.
  virtual void leaveMesh(Mesh *M) const;
  
protected:
  MeshX3DBuilderStateVariables *stateVariables; 
};

}
}

#endif
