/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_MeshBuilder.h                               //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHBUILDER_H
#define MESHBUILDER_H

#include "MESH_Mesh.h"
#include "MESH_VertexSet.h"
#include "X3D_TemplateMeshBuilder.h"

#include <iostream>

namespace X3DTK {
namespace X3D {

class IndexedFaceSet;
class Coordinate;

typedef TemplateMeshBuilder<MESH::MeshData, MESH::VertexData, MESH::EdgeData, MESH::FaceData> MeshBuilder;

/// Specialization of the TemplateMeshBuilderGeometryTraits.

template<>
struct TemplateMeshBuilderGeometryTraits<MESH::MeshData, MESH::VertexData, MESH::EdgeData, MESH::FaceData, IndexedFaceSet>
{
  /// Start function.
  X3DTK_API static void init(MESH::TemplateMesh<MESH::MeshData, MESH::VertexData, MESH::EdgeData, MESH::FaceData> *mesh, IndexedFaceSet *I);
  /// processNewFace function.
  X3DTK_API static void processNewFace(MESH::TemplateMesh<MESH::MeshData, MESH::VertexData, MESH::EdgeData, MESH::FaceData> *mesh, IndexedFaceSet *I, MESH::SFTemplateFace<MESH::FaceData, MESH::VertexData, MESH::EdgeData> *F);
  /// End function.
  X3DTK_API static void finish(MESH::TemplateMesh<MESH::MeshData, MESH::VertexData, MESH::EdgeData, MESH::FaceData> *mesh, IndexedFaceSet *I);
};

/// Specialization of the TemplateMeshBuilderCoordinateTraits.

template<>
struct TemplateMeshBuilderCoordinateTraits<MESH::VertexData, MESH::EdgeData, MESH::FaceData, Coordinate>
{
  /// Process function.
  X3DTK_API static void process(MESH::TemplateVertexSet<MESH::VertexData, MESH::EdgeData, MESH::FaceData> *vertexSet, Coordinate *N);
};

}
}

#endif
