/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_X3DUrlObject.h                              //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DURLOBJECT_H
#define X3DURLOBJECT_H

#include "X3D_X3DObject.h"
#include "X3DFileElement.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/networking.html">Networking 
/// component</a> for the X3D nodes.

class X3DTK_API X3DUrlObject : public X3DObject
{
public:
  /// Constructor.
  X3DUrlObject();
  /// Virtual destructor.
  virtual ~X3DUrlObject();
  
  /// Sets the url attribute.
  void setUrl(const MFString &url);

  /// Gets the url attribute.
  inline const MFString &getUrl() const {return _url;};

  /// Load method.
  virtual void load(const X3DFileElement *element);
  /// Write method.
  virtual SFString &write(SFString &output) const;

protected:
  /// Copy constructor.
  X3DUrlObject(const X3DUrlObject &N);  

private:  
  /// url.
  MFString _url;  
};

}
}

#endif
