#include "MESH_DFSCoreWalker.h"
#include "MESH_X3DGroupingNode.h"
#include "MESH_X3DMeshNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

DFSCoreWalker::DFSCoreWalker()
: X3DComponentWalker()
{
  defineComponentName("Core", "MESH");
  
  defineWalkingFunction(&DFSCoreWalker::walkX3DGroupingNode);
  defineWalkingFunction(&DFSCoreWalker::walkX3DMeshNode);
}

DFSCoreWalker::~DFSCoreWalker()
{
}

void DFSCoreWalker::walkX3DGroupingNode(X3DGroupingNode *N) const
{
  visitor->enter(N);
  
  MFNode children = N->getChildren();
  for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
  {  
    if ((*it != 0) && (visitor->walkOn(N, *it)))
      walker->walk(*it);
  }    
  
  visitor->leave(N);
}

void DFSCoreWalker::walkX3DMeshNode(X3DMeshNode *N) const
{
  visitor->enter(N);
  
  SFNode C = N->getVertexSet();
  if ((C != 0) && (visitor->walkOn(N, C)))
    walker->walk(C);
  
  visitor->leave(N);
}

}
}
