/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            MESH_X3DMeshNode.h                              //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESH_X3DMESHNODE_H
#define MESH_X3DMESHNODE_H

#include "MESH_SceneGraphTypes.h"
#include "MESH_X3DNode.h"

namespace X3DTK {
namespace X3D {

class X3DAppearanceNode;

}

/// MESH namespace including the MESH scene graph as well as its related classes.

namespace MESH {

/// Base class for the Mesh graph Scene.

class X3DTK_API X3DMeshNode : public X3DNode
{
public:
  /// Constructor.
  X3DMeshNode();
  /// Virtual destructor.
  virtual ~X3DMeshNode();
  
  /// Sets the X3DAppearanceNode.
  void setX3DAppearanceNodeChild(X3D::X3DAppearanceNode *N);
  
  /// Gets the VertexSet.
  inline SFNode getVertexSet() const {return vertexSet;};
  
  /// Gets the X3DAppearanceNode.
  inline X3D::X3DAppearanceNode *getX3DAppearanceNodeChild() const {return _x3dAppearance;};

protected:
  /// Copy constructor.
  X3DMeshNode(const X3DMeshNode &N);
  
  /// VertexSet.
  SFNode vertexSet; 

private:
  X3D::X3DAppearanceNode *_x3dAppearance;
};

}
}

#endif
