#include "X3D_Box.h"

namespace X3DTK {
namespace X3D {

Box::Box()
:X3DGeometry3DNode(), _size(SFVec3f(2.0f, 2.0f, 2.0f))
{
  defineTypeName("Box", "Geometry3D");
}

Box::Box(const SFVec3f &size)
:X3DGeometry3DNode(), _size(size)
{
  defineTypeName("Box", "Geometry3D");
}

Box::Box(const Box &B)
:X3DGeometry3DNode(B), _size(B._size)
{
}

SFAbstractNode Box::clone() const
{
  return new Box(*this);
}

Box::~Box()
{
}

void Box::setSize(const SFVec3f &size)
{
  _size = size;
}

void Box::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("size");
  if (index != -1)
    _size = SFVec3f(element->getAttribute(index));
}

SFString &Box::write(SFString &output) const
{
  if (_size != SFVec3f(2.0f, 2.0f, 2.0f))
      output += " size=\"" + toSFString(_size) + "\"";
      
  return output;    
}

}
}
