/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_TextureTransform.h                          //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEXTURETRANSFORM_H
#define TEXTURETRANSFORM_H

#include "X3D_X3DTextureTransform2DNode.h"

namespace X3DTK {
namespace X3D {

/// Class of the <a href="../../doc/X3DSpecs/Part01/components/texturing.html">
/// Texturing component</a> defining a TextureTransform
/// (<a href="../../doc/X3DSpecs/Part01/components/texturing.html#TextureTransform">
/// documentation</a>).

class X3DTK_API TextureTransform : public X3DTextureTransform2DNode
{
public:  
  /// Constructor.
  TextureTransform();
  /// Constructs a X3DTextureTransform2DNode from its attributes.
  TextureTransform(const SFVec2f &center, 
	    const SFFloat &rotation, 
	    const SFVec2f &scale, 
	    const SFVec2f &translation);
  /// Clones the node.
  virtual SFAbstractNode clone() const;
  /// Destructor.
  virtual ~TextureTransform();

protected:
  /// Copy constructor.
  TextureTransform(const TextureTransform &T);
};

}
}

#endif
