#include "MESH_Disassembler.h"
#include "MESH_DisassemblerCoreVisitor.h"
#include "MESH_DFSGraphTraversal.h"

namespace X3DTK {
namespace MESH {

Disassembler::Disassembler()
{
  stateVariables = GraphTraversal::getInstanceOf<DisassemblerStateVariables>();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new DisassemblerCoreVisitor());
}

Disassembler::~Disassembler()
{
  GraphTraversal::removeInstanceOf<DisassemblerStateVariables>();

  delete graphTraversal;
}

void Disassembler::disassemble(float value, SFNode N)
{
  stateVariables->setValue(value);
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
}

}
}

