/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            MESH_Disassembler.h                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHDISASSEMBLER_H
#define MESHDISASSEMBLER_H

#include "MESH_DisassemblerStateVariables.h"
#include "X3DOnePassProcessor.h"

namespace X3DTK {
namespace MESH {

/// Disassembler processor.

class X3DTK_API Disassembler : public X3DOnePassProcessor
{
public:
  /// Constructor.
  Disassembler();
  /// Destructor.
  virtual ~Disassembler();
  
  /// Prints the informations relative to N.
  virtual void disassemble(float value, SFNode N);
 
protected:
  DisassemblerStateVariables *stateVariables;
};

}
}

#endif

