#include "MESH_DisassemblerCoreVisitor.h"
#include "MESH_Transform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

DisassemblerCoreVisitor::DisassemblerCoreVisitor()
{
  // Enter functions.
  defineEnterFunction(&DisassemblerCoreVisitor::enterTransform);
  
  // Leave functions.
  defineLeaveFunction(&DisassemblerCoreVisitor::leaveTransform);
  
  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<DisassemblerStateVariables>();
}

DisassemblerCoreVisitor::~DisassemblerCoreVisitor()
{
}

void DisassemblerCoreVisitor::enterTransform(Transform *T) const
{
  SFMatrix34f wT = stateVariables->getMatrix();
  SFPoint3f P = SFPoint3f(T->getTranslation());
  cout << "P init = " << P << endl;
  P = wT*P;
  P = stateVariables->getValue()*P;
  P = (wT.i())*P;
  cout << "P end = " << P << endl;
  T->setTranslation(SFVec3f(P));
  stateVariables->pushMatrix(T->getTransform());
}

void DisassemblerCoreVisitor::leaveTransform(Transform *) const
{
  stateVariables->popMatrix();
}

}
}
