#include "MESH_Disassembler.h"

namespace X3DTK {
namespace MESH {

DisassemblerStateVariables::DisassemblerStateVariables()
: StateVariables()
{
}

DisassemblerStateVariables::~DisassemblerStateVariables()
{
}

void DisassemblerStateVariables::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

void DisassemblerStateVariables::finish()
{
  _matrixStack.clear();
}

void DisassemblerStateVariables::setValue(float value)
{
  _value = value;
}

void DisassemblerStateVariables::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

void DisassemblerStateVariables::popMatrix()
{
  _matrixStack.pop_front();
}

}
}
