#include "MESH_MeshEdgesDrawer.h"
#include "MESH_DFSGraphTraversal.h"
#include "MESH_MeshEdgesDrawerCoreVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

MeshEdgesDrawer::MeshEdgesDrawer()
: X3DOnePassProcessor()
{
  stateVariables = GraphTraversal::getInstanceOf<MeshEdgesDrawerStateVariables>();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MeshEdgesDrawerCoreVisitor());
}

MeshEdgesDrawer::~MeshEdgesDrawer()
{
  GraphTraversal::removeInstanceOf<MeshEdgesDrawerStateVariables>();
  
  delete graphTraversal;
}

void MeshEdgesDrawer::draw(X3DNode *N, bool selection)
{
  stateVariables->setSelectionMode(selection);
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
}

}
}

