#include "MESH_MeshEdgesDrawerStateVariables.h"
#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

MeshEdgesDrawerStateVariables::MeshEdgesDrawerStateVariables()
: StateVariables(), _selectionMode(false), _oneColorPerMesh(true)
{}

void MeshEdgesDrawerStateVariables::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

void MeshEdgesDrawerStateVariables::finish()
{
  _matrixStack.pop_front();
  if (_matrixStack.size() != 0)
  {
    cx3d << "MeshEdgesDrawerStateVariables::finishTraversal: Non empty matrix stack at the end of MeshEdgesDrawer traversal" << endl;
    _matrixStack.clear();
  }
  
  _matrixVector.clear();
  _meshVector.clear();
}

void MeshEdgesDrawerStateVariables::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

void MeshEdgesDrawerStateVariables::popMatrix()
{
  _matrixStack.pop_front();
}

void MeshEdgesDrawerStateVariables::storeMesh(Mesh *mesh)
{
  _matrixVector.push_back(_matrixStack.front());
  _meshVector.push_back(mesh);
}

int MeshEdgesDrawerStateVariables::getCurrentMeshId()
{
  return _matrixVector.size() - 1;
}

}
}
