#include "MESH_MeshFacesDrawer.h"
#include "MESH_DFSGraphTraversal.h"
#include "MESH_MeshFacesDrawerCoreVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

MeshFacesDrawer::MeshFacesDrawer()
: X3DOnePassProcessor()
{
  stateVariables = GraphTraversal::getInstanceOf<MeshFacesDrawerStateVariables>();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MeshFacesDrawerCoreVisitor());
}

MeshFacesDrawer::~MeshFacesDrawer()
{
  GraphTraversal::removeInstanceOf<MeshFacesDrawerStateVariables>();
  
  delete graphTraversal;
}

void MeshFacesDrawer::changeOneColorPerMesh() 
{
  stateVariables->changeOneColorPerMesh();
}

void MeshFacesDrawer::draw(X3DNode *N, bool selection)
{
  stateVariables->setSelectionMode(selection);
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
}

}
}

