#include "X3D_InlineLoaderNetworkingVisitor.h"
#include "X3D_Inline.h"
#include "X3D_Scene.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

InlineLoaderNetworkingVisitor::InlineLoaderNetworkingVisitor()
: NetworkingVisitor()
{
  // Enter functions.
  defineEnterFunction(&InlineLoaderNetworkingVisitor::enterInline);
  // Leave functions.
  defineLeaveFunction(&InlineLoaderNetworkingVisitor::leaveInline);
  
  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<InlineLoaderStateVariables>();
}

InlineLoaderNetworkingVisitor::~InlineLoaderNetworkingVisitor()
{
}

void InlineLoaderNetworkingVisitor::enterInline(Inline *I) const
{
  X3DNode *F = stateVariables->getTop();
  X3DLoader *loader = stateVariables->getLoader();
  if ((stateVariables->isForced()) || (I->getLoad()))
  {
    Scene *s = loader->load(I->getUrl().front());
    MFNode children = s->getChildren();

    delete s;
    F->removeChild(I);
          
    for (MFNode::const_iterator it = children.begin(); it != children.end(); ++it)
      F->addChild(*it);
  }
  stateVariables->addVisitedNode(I);  
  stateVariables->pushNode(I);
}

void InlineLoaderNetworkingVisitor::leaveInline(Inline *I) const
{
  if (I->getParentList().empty())
    delete I;
  stateVariables->popNode();
}

}
}
