#include "X3D_TemplateMeshBuilderCoreVisitor.h"
#include "X3D_Scene.h"
#include "MESH_Scene.h"
#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

TemplateMeshBuilderCoreVisitor::TemplateMeshBuilderCoreVisitor()
: CoreVisitor()
{
  // Enter functions.
  defineEnterFunction(&TemplateMeshBuilderCoreVisitor::enterScene);
  defineEnterFunction(&TemplateMeshBuilderCoreVisitor::enterX3DNode);
  
  // WalkOn functions.
  defineWalkOnFunction(&TemplateMeshBuilderCoreVisitor::walkOnX3DNode);
  
  // Leave functions.
  defineLeaveFunction(&TemplateMeshBuilderCoreVisitor::leaveX3DNode);

  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<TemplateMeshBuilderStateVariables>();
};

TemplateMeshBuilderCoreVisitor::~TemplateMeshBuilderCoreVisitor() 
{
};

void TemplateMeshBuilderCoreVisitor::enterScene(Scene *S) const
{
  MESH::SFNode MS = stateVariables->getNode(S);
  if (MS == 0)
  {
    MS = new MESH::Scene();
    stateVariables->addCoupleNode(S, MS);
  }
  stateVariables->pushNode(MS);
};

void TemplateMeshBuilderCoreVisitor::enterX3DNode(X3DNode *N) const
{
  stateVariables->pushNode(0);
}

bool TemplateMeshBuilderCoreVisitor::walkOnX3DNode(X3DNode *N, SFAbstractNode) const
{
  return ((stateVariables->getTop() != 0) && (stateVariables->getChildrenVisit()));
}

void TemplateMeshBuilderCoreVisitor::leaveX3DNode(X3DNode *N) const
{
  stateVariables->popNode();
};

}
}
