/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_TemplateMeshBuilderShapeVisitor.h           //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERSHAPEVISITOR_H
#define TEMPLATEMESHBUILDERSHAPEVISITOR_H

#include "X3D_ShapeVisitor.h"
#include "X3D_TemplateMeshBuilderStateVariables.h"

namespace X3DTK {
namespace X3D {

class Shape;
class X3DAppearanceNode;

/// Visitor for the Shape component of the TemplateMeshBuilder module.

class X3DTK_API TemplateMeshBuilderShapeVisitor : public ShapeVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderShapeVisitor();
  /// Destructor.
  virtual ~TemplateMeshBuilderShapeVisitor();

  /// Enters a Shape.
  virtual void enterShape(Shape *S) const;
  /// Enters an X3DAppearanceNode.
  virtual void enterX3DAppearanceNode(X3DAppearanceNode *N) const;
  
  /// Walks on a Shape.
  virtual bool walkOnShape(Shape *S, SFAbstractNode child) const;
  
  /// Leaves a Shape.
  virtual void leaveShape(Shape *S) const;
  /// Leaves an X3DAppearanceNode.
  virtual void leaveX3DAppearanceNode(X3DAppearanceNode *N) const;

protected:
  TemplateMeshBuilderStateVariables *stateVariables;
};

}
}

#endif
