#include "X3DComponentWalker.h"

#include <algorithm>

using namespace X3DTK;
using namespace std;

X3DComponentWalker::X3DComponentWalker()
: walker(0), visitor(0)
{
}

void X3DComponentWalker::setWalker(Walker *walker)
{
  this->walker = walker; 
}

void X3DComponentWalker::setVisitor(Visitor *visitor)
{
  this->visitor = visitor; 
}

X3DComponentWalker::~X3DComponentWalker()
{
  //delete the creation functions
  for (WalkingDict::iterator it = _walkingDict.begin(); it != _walkingDict.end(); ++it)
    delete (*it).second; 
}

WalkingFunction *X3DComponentWalker::getWalkingFunctionOf(const SFType *type) const
{
  SFString nodeName = type->getEncodedName();
  WalkingDict::const_iterator it = _walkingDict.find(nodeName);
  if ((it != _walkingDict.end()) && ((*it).second->isActive()))
      return (*it).second;
      
  //not found  
  return 0;  
}
